<?php

namespace Treewec;

/**
 * Test class for URLArgsInspector.
 * Generated by PHPUnit on 2012-03-25 at 16:36:38.
 * @group url
 */
class URLArgsInspectorTest extends \PHPUnit_Framework_TestCase {

    /** @var ExceptionHelper */
    private $exceptionHelper;
    /** @var URLArgsInspector */
    private $inspector;

    protected function setUp() {        
        $this->exceptionHelper = new ExceptionHelper();
    }

    public function testAddInspectedObject() {        
        // argument must be instanceof Treewec\URLArgs
        $this->exceptionHelper->catchExceptionInCallback('\Exception', array($this->inspector, 'addInspectedObject'), null);
    }

    public function testCheck() {
        // valid -> no exception
        $this->setInspector(array('path' => ''));
        $this->setInspector(array('path' => 'teams/'));
        // invalid -> exception is thrown
        $this->setInspectorAndAssertException(array('path' => '/teams/'));
        $this->setInspectorAndAssertException(array('path' => '../../etc/password'));
        $this->setInspectorAndAssertException(array('path' => 'password/////'));
        $this->setInspectorAndAssertException(array('path' => 'hello/' . TREEWEC_NAME_OF_INDEX_FILE));
        if (TREEWEC_URL_REWRITE) {
            $_SERVER['REQUEST_URI'] = 'index.php?path=hello';
            $this->setInspectorAndAssertException(array('path' => 'hello'));
        }
    }

    private function setInspectorAndAssertException($array) {
        $this->setInspector($array);
        $this->assertException();
    }
    
    private function setInspector($array) {
        $this->inspector = new URLArgsInspector();
        $arrayHolder = new Holders\ArrayHolder($array);
        $this->inspector->addInspectedObject(URLArgs::createFromArrayHolder($arrayHolder));
    }
    
    private function assertException($method = 'check') {
        $this->exceptionHelper->catchExceptionInCallback(
                '\Treewec\Exceptions\ClientRequestException', 
                array($this->inspector, $method), 
                false
        );
    }
    
}

?>
